#include <stdio.h>

/*
  Implement sum() to seperately sum the
  odd and even numbers in an array of integers,
  and then return the product.

    - using `goto` and labels
    - without using `for`, `while`, or `do`
    - with only one-armed `if`s
    - with only `goto` in the "then" part of `if`
*/

int sum(int *a, int len)
{
  int sum_even = 0;
  int sum_odd = 0;
  int index = 0;
  
 fakewhile:
  if(index < len) goto testodd;
  return sum_even * sum_odd;

 testodd:
  index++;
  if(!(a[index-1] & 1)) goto addeven; 
    sum_odd = sum_odd + a[index-1];
    goto fakewhile;
 addeven:
    sum_even = sum_even + a[index-1];
    goto fakewhile;
}

int a[] = {1, 2, 5, 7, 4, 6, 8, 0, 11};

int main()
{
  int v = sum(a, sizeof(a) / sizeof(int));

  printf("%d\n", v);

  return 0;
}
