#include <stdio.h>

/*
  Implement sum() to sum *only the odd numbers*
  in an array of integers
    - using `goto` and labels
    - without using `for`, `while`, or `do`
    - with only one-armed `if`s
    - with only `goto` in the "then" part of `if`
*/

int sum(int *a, int len)
{
  int sum_so_far = 0;
  int index = 0;
  
 fakewhile:
  if(index < len) goto testodd;
  return sum_so_far;

 testodd:
  index++;
  if(!(a[index-1] & 1)) goto fakewhile; 
  doit:
    sum_so_far = sum_so_far + a[index-1];
    goto fakewhile;
}

int a[] = {1, 2, 5, 7, 4, 6, 8, 0, 11};

int main()
{
  int v = sum(a, sizeof(a) / sizeof(int));

  printf("%d\n", v);

  return 0;
}
